﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using Quartz;

namespace LJZCWeather
{
    public class IndexJob : IJob
    {
        public void Execute(JobExecutionContext context)
        {
            DoIndex();
        }
        public void DoIndex()
        {
            //使用的是163服务器（因为我的邮箱是@163.com的 ）
            string strSmtpServer = "smtp.163.com";
            //信息来自哪个邮箱（自己的邮箱）
            string StrFrom = "***@163.com";
            //自己邮箱的密码
            string strFromPass = "***";
            //主题
            string strSubject = "田鑫制作（近三天）天气预报软件：";
            //要发送去哪里，自己注册的手机邮箱，添加数组：可以放多个邮箱（家人也可以享受这个功能）
            string[] strto = {"***@139.com" };
            //发送的内容
            string content = null;
            string[] Weath = null;
            //我这里使用的缓存技术，因为免费的用户使用的话不能长时间的获取数据（人家的服务器受不了啊）！            
            if (HttpRuntime.Cache["We"] == null)
            {
                //调用Web服务，得到你所需要的内容，我是济南的，所以CityCode是“937"
                //找自己对应的城市，调用getRegionProvince ()获得省份之后再调用getSupportCityString()获得自己城市的Code
                ServiceReference1.WeatherWSSoapClient s = new ServiceReference1.WeatherWSSoapClient("WeatherWSSoap");
                Weath = s.getWeather("937", "");
                HttpRuntime.Cache.Insert("We", Weath, null, DateTime.Now.AddHours(3), TimeSpan.Zero);
            }
            else
            {
                Weath = (string[])HttpRuntime.Cache["We"];
            }
            if (Weath.Length > 1)
            {
                for (int i = 0; i < Weath.Length; i++)
                {
                    //今天的天气状况
                    string TodayWeather = Weath[7].ToString();
                    string TodayWenDU = Weath[8].ToString() + Weath[9].ToString();
                    //明天的天气状况
                    string NextWeather = Weath[12].ToString();
                    string NextWenDU = Weath[13].ToString() + Weath[14].ToString();
                    //后天的天气状况
                    string HoutianWeather = Weath[17].ToString();
                    string HoutianWenDU = Weath[18].ToString() + Weath[19].ToString();
                    //短信接收到的内容
                    content = "济南天气：" + TodayWeather + TodayWenDU + "," + "\r\n" + NextWeather + NextWenDU + "," + "\r\n" + HoutianWeather + HoutianWenDU;
                }
            }
            for (int i = 0; i < strto.Length; i++)
            {
                //调用SendSMTPEMail()进行发送邮箱(手机邮箱)
                this.SendSMTPEMail(strSmtpServer, StrFrom, strFromPass, strto[i], strSubject, content);
            }
        }
        //发送邮箱方法
        private bool SendSMTPEMail(string strSmtpServer, string strFrom, string strFromPass, string strto, string strSubject, string strBody)
        {
            try
            {
                System.Net.Mail.SmtpClient client = new System.Net.Mail.SmtpClient(strSmtpServer);
                client.UseDefaultCredentials = false;
                client.Credentials = new System.Net.NetworkCredential(strFrom, strFromPass);
                client.DeliveryMethod = System.Net.Mail.SmtpDeliveryMethod.Network;
                System.Net.Mail.MailMessage message = new System.Net.Mail.MailMessage(strFrom, strto, strSubject, strBody);
                message.BodyEncoding = System.Text.Encoding.UTF8;
                message.IsBodyHtml = true;
                client.Send(message);
                return true;
            }
            catch (Exception ex)
            {
                string ms = ex.Message;
                return false;
            }
        }
    }
}
